'*******************************************************************************
'************                 Regnersteuerung20_Menue            ***************
'*******************************************************************************

'name                     : Regnersteuerung20_Menue.inc
'copyright                : (c) 25.10.2020 jep
'purpose                  : Steuert Rasenbewsserung bei Anne


'===============================================================================
'================================   Menueauswahl   =============================
'===============================================================================
$NOCOMPILE

Declare Sub Menue()
Declare Sub Getdatetime()                                   'aktuelle Zeit holen
Declare Sub SetDate()
Declare Sub SetTime()
Declare Sub Set1307_1sec_tick()

goto MenueEnd
'_______________________________________________________________________________

Sub Menueanzeige()
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text Text , 10 , 10 , 2 , Blue , Black , 2
   LCD_Line 1 , 70 , 320 , 70 , 2 , White                   'make line
   LCD_Line 1 , 112 , 320 , 112 , 2 , White                 'make line
End Sub

Sub Menue()
      Menue_aktiv = 1
      Displaybeleuchtung = 1
      Beleuchtungstimer = max_Beleuchtungsdauer
      Menue_Timeout = 60                                    '60 sec um Menue zu whlen

   Menue1:
      Text = "Menue 1"
      Call Menueanzeige
      LCD_Text "OK = Wasser Stop" , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Wasser_Stop
         Debounce up , 0 , Menue6
         Debounce down , 0 , Menue2
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Menue2:
      Text = "Menue 2"
      Call Menueanzeige
      LCD_Text "OK= Zeit stellen" , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Zeit_stellen
         Debounce up , 0 , Menue1
         Debounce down , 0 , Menue4                         'Menue 3 berspringen
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Menue3:
      Text = "Menue 3"
      Call Menueanzeige
      LCD_Text "OK = Reserve 1  " , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Res_1
         Debounce up , 0 , Menue2
         Debounce down , 0 , Menue4
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Menue4:
      Text = "Menue 4"
      Call Menueanzeige
      LCD_Text "Entwssern Sued " , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Entw_Sued
         Debounce up , 0 , Menue2                           'Menue 3 berspringen
         Debounce down , 0 , Menue5
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Menue5:
      Text = "Menue 5"
      Call Menueanzeige
      LCD_Text "Entwssern West " , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Entw_West
         Debounce up , 0 , Menue4
         Debounce down , 0 , Menue6
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Menue6:
      Text = "Menue 6"
      Call Menueanzeige
      LCD_Text "Summer schalten " , 0 , 80 , 2 , Red , White , 1
      LCD_Text "mit UP und DOWN " , 0 , 120 , 2 , White , Black , 1
      LCD_Text "= weitere Menues" , 0 , 150 , 2 , White , Black , 1
      LCD_Text "LINKS und RECHTS" , 0 , 180 , 2 , Yellow , Black , 1
      LCD_Text " ==> Menue Ende " , 0 , 210 , 2 , Yellow , Black , 1
      Do
         Debounce OK , 0 , Buzzer
         Debounce up , 0 , Menue5
         Debounce down , 0 , Menue1
         Debounce Links , 0 , Ende_Eingabe
         Debounce Rechts , 0 , Ende_Eingabe
         If Menue_Timeout = 0 Then Goto Ende_Eingabe
         Reset Watchdog
      Loop

   Ende_Eingabe:
      Call Titelanzeige
      if West_aktiv = 1 then
         Call RLZ_West_anzeigen
         goto Menue_End
      end if
      if Sued_aktiv = 1 then
         Call RLZ_Sued_anzeigen
         goto Menue_End
      end if
      Call Zeitanzeige
      Call Datumanzeige
  Menue_End:
      Menue_aktiv = 0
End Sub

'===========================================================================
'========================  Menue1: Wasser Stop  ============================
'===========================================================================

Wasser_Stop:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Wasser wird" , 20 , 10 , 1 , Red , Black , 2
   LCD_Text "gestoppt" , 50 , 40 , 1 , Red , Black , 2
   gosub Stop_S_W
   Reset Watchdog
   wait 3                                                   '3 sec Anzeige
   Reset Watchdog
   goto Ende_Eingabe


'===========================================================================
'================= Menue2: Zeit und Datum einstellen =======================
'===========================================================================


Zeit_stellen:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "DS1307 richten" , 0 , 40 , 1 , White , Black , 1
   LCD_Text "mit Auf und Ab resp." , 0 , 80 , 1 , White , Black , 1
   LCD_Text "Links und Rechts" , 0 , 120 , 1 , White , Black , 1
   LCD_Text "Zeit und Datum einstellen" , 0 , 160 , 1 , White , Black , 1
   LCD_Text "Mit OK abschliessen" , 0 , 200 , 1 , White , Black , 1
   Menue_Timeout = 90                                       '90 sec Zeit zum stellen
   Wait 2

'___________________________________

   gosub GetDateTime                                        'Zeit und Datum aus dem RTC holen

Zeit_stellen_Tag:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Tag einstellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Datum , 60 , 120 , 1 , White , Black , 2        'Date$

Zeit_stellen_Tag1:
   Do
      LCD_Text Hex(bcd_day) , 60 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Tagplus
      Debounce Down , 0 , Tagminus
      Debounce Links , 0 , Zeit_stellen_Sec
      Debounce Rechts , 0 , Zeit_stellen_Monat
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
     Reset Watchdog
   Loop
Tagplus:
   _day = _day + 1
   if _day > 31 then _day = 1
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Tag1
Tagminus:
   _day = _day - 1
   if _day = 0 then _day = 31
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Tag1
'____________

Zeit_stellen_Monat:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Monat stellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Datum , 60 , 120 , 1 , White , Black , 2        'Date$

Zeit_stellen_Monat1:
   Do
      LCD_Text Hex(bcd_month) , 132 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Monatplus
      Debounce Down , 0 , Monatminus
      Debounce Links , 0 , Zeit_stellen_Tag
      Debounce Rechts , 0 , Zeit_stellen_Jahr
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
      Reset Watchdog
   Loop
Monatplus:
   _month = _month + 1
   if _month > 12 then _month = 1
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Monat1
Monatminus:
   _month = _month - 1
   if _month = 0 then _month = 1
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Monat1
'_______________

Zeit_stellen_Jahr:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Jahr einstellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Datum , 10 , 120 , 1 , White , Black , 2        'Date$

Zeit_stellen_Jahr1:
   Do
      LCD_Text Hex(bcd_year) , 204 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Jahrplus
      Debounce Down , 0 , Jahrminus
      Debounce Links , 0 , Zeit_stellen_Monat
      Debounce Rechts , 0 , Zeit_stellen_Std
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
      Reset Watchdog
   Loop
Jahrplus:
   _Year = _Year + 1
   if _Year > 99 then _Year = 0
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Jahr1
Jahrminus:
   _Year = _Year - 1
   if _Year = 255 then _Year = 99
   Call setDate
   Call GetDateTime
   goto Zeit_stellen_Jahr1
'__________________

Zeit_stellen_Std:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Std einstellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Zeit , 60 , 120 , 1 , White , Black , 2         'Time$

Zeit_stellen_Std1:
   Do
   LCD_Text Hex(bcd_hour) , 60 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Stdplus
      Debounce Down , 0 , Stdminus
      Debounce Links , 0 , Zeit_stellen_Jahr
      Debounce Rechts , 0 , Zeit_stellen_Min
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
      Reset Watchdog
   Loop
Stdplus:
   _hour = _hour + 1
   if _hour = 24 then _hour = 0
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Std1
Stdminus:
   _hour = _hour - 1
   if _hour = 255 then _hour = 23
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Std1
'__________________

Zeit_stellen_Min:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Min einstellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Zeit , 60 , 120 , 1 , White , Black , 2         'Time$

Zeit_stellen_Min1:
   Do
      LCD_Text Hex(bcd_min) , 132 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Minplus
      Debounce Down , 0 , Minminus
      Debounce Links , 0 , Zeit_stellen_Std
      Debounce Rechts , 0 , Zeit_stellen_Sec
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
      Reset Watchdog
   Loop
Minplus:
   _min = _min + 1
   if _min > 59 then _min = 0
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Min1
Minminus:
   _min = _min - 1
   if _min > 59 then _min = 0
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Min1
'_________________

Zeit_stellen_Sec:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Sec einstellen" , 10 , 50 , 2 , White , Black , 1
   LCD_Text Zeit , 60 , 120 , 1 , White , Black , 2         'Time$

Zeit_stellen_Sec1:
   Do
      LCD_Text Hex(bcd_sec) , 204 , 120 , 1 , White , Black , 2
      Debounce Up , 0 , Secplus
      Debounce Down , 0 , Secminus
      Debounce Links , 0 , Zeit_stellen_Min
      Debounce Rechts , 0 , Zeit_stellen_Tag
      Debounce Ok , 0 , Zeit_speichern_Ende
      If Menue_Timeout = 0 Then Goto Zeitausgabe_Ende
      Reset Watchdog
   Loop
Secplus:
   _sec = _sec + 1
   if _sec > 59 then _sec = 0
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Sec1
Secminus:
   _sec = _sec - 1
   if _sec > 59 then _sec = 0
   Call setTime
   Call GetDateTime
   goto Zeit_stellen_Sec1
'_________________________

Zeit_speichern_Ende:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "Zeit gestellt" , 30 , 50 , 2 , Red , Black , 1

Zeitausgabe:
   Call GetDateTime
   LCD_Text Datum , 80 , 100 , 2 , White , Black , 1
   LCD_Text Zeit , 80 , 150 , 2 , White , Black , 1         'Datum    Zeit
   waitms 10
   Debounce Ok , 0 , Ende_Eingabe                           'und mit OK zurck
   Reset Watchdog
   goto Zeitausgabe

Zeitausgabe_Ende:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   Call GetDateTime
   LCD_Text Datum , 80 , 100 , 2 , White , Black , 1
   LCD_Text Zeit , 80 , 150 , 2 , White , Black , 1         'Datum    Zeit
   waitms 10
   Reset Watchdog
   goto Zeitausgabe


'===========================================================================
'===========================  Menue3: Reserve 1  ===========================
'===========================================================================

Res_1:
   goto Ende_Eingabe                                        'und zurck


'===========================================================================
'========================  Menue4: Entwssern Sd  =========================
'===========================================================================

Entw_Sued:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "alle Tasten => Abbruch" , 10 , 50 , 1 , Red , Black , 1
   LCD_Text "Entwsserung Sued" , 10 , 100 , 1 , Red , Black , 1
   LCD_Text "lauft noch:" , 10 , 125 , 1 , Red , Black , 1
   Entwaesserungstimer = Entwaesserungstime                 '5 Minuten
   Sued_K2 = 1                                              'Magnetventil auf
   Do
      If Neue_sekunde = 1 Then                              'neue Sekunde
         Neue_sekunde = 0
         Entwaesserungstimer = Entwaesserungstimer - 1
         LCD_Text Str(Entwaesserungstimer) , 60 , 175 , 1 , Red , Black , 2       'Zeit
         If Entwaesserungstimer = 0 then
            goto Entw_EndS
         End if
      End if
      Debounce OK , 0 , Entw_EndS
      Debounce up , 0 , Entw_EndS
      Debounce down , 0 , Entw_EndS
      Debounce Links , 0 , Entw_EndS
      Debounce Rechts , 0 , Entw_EndS
      Reset Watchdog
   Loop
  Entw_EndS:
   Sued_K2 = 0                                              'Magnetventil zu
goto Ende_Eingabe                                           'und zurck


'===========================================================================
'========================  Menue5: Entwssern West  ========================
'===========================================================================

Entw_West:
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "alle Tasten => Abbruch" , 10 , 50 , 1 , Red , Black , 1
   LCD_Text "Entwsserung West" , 10 , 100 , 1 , Red , Black , 1
   LCD_Text "lauft noch:" , 10 , 125 , 1 , Red , Black , 1
   Entwaesserungstimer = 300                                '5 Minuten
   West_K1 = 1                                              'Magnetventil auf
   Do
      If Neue_sekunde = 1 Then                              'neue Sekunde
         Neue_sekunde = 0
         Entwaesserungstimer = Entwaesserungstimer - 1
         LCD_Text Str(Entwaesserungstimer) , 60 , 175 , 1 , Red , Black , 2       'Zeit
         If Entwaesserungstimer = 0 then
            goto Entw_EndW
         End if
      End if
      Debounce OK , 0 , Entw_EndW
      Debounce up , 0 , Entw_EndW
      Debounce down , 0 , Entw_EndW
      Debounce Links , 0 , Entw_EndW
      Debounce Rechts , 0 , Entw_EndW
      Reset Watchdog
   Loop
  Entw_EndW:
   West_K1 = 0                                              'Magnetventil zu
goto Ende_Eingabe                                           'und zurck

'===========================================================================
'====================  Menue6: Summer schalten  ============================
'===========================================================================

Buzzer:
   Menue_Timeout = 30                                       '30 sec um Auszuwhlen
   Displaybeleuchtung = 0
   LCD_Clear Black
   Displaybeleuchtung = 1
   LCD_Text "mit UP:   Summer EIN" , 10 , 20 , 1 , Green , Black , 1
   LCD_Text "mit DOWN: Summer AUS" , 10 , 50 , 1 , Red , Black , 1       'Summer
   LCD_Text "mit OK:      zurueck" , 10 , 100 , 1 , White , Black , 1

   If Summer_aktiv = 1 then
      goto Summer_ein
    else
      goto Summer_aus
   End if

Summer_schalten:
   Do
      Debounce UP , 0 , Summer_ein
      Debounce DOWN , 0 , Summer_aus
      Debounce OK , 0 , Ende_Eingabe                        'und zurck
      if Menue_Timeout = 0 then goto Ende_Eingabe
      Reset Watchdog
   Loop

Summer_ein:
   Summer_aktiv = 1
   LCD_Text "Summer ist EIN" , 10 , 170 , 2 , Green , Black , 1
   goto Summer_schalten

Summer_aus:
   Summer_aktiv = 0
   LCD_Text "Summer ist AUS" , 10 , 170 , 2 , Red , Black , 1
   goto Summer_schalten


'_____________________________________________________________________________

'called from ds1307clock.lib

Sub Getdatetime:
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds1307w                                         ' send address
   I2cwbyte 0                                               ' start address in 1307

   I2cstart                                                 ' Generate start code
   I2cwbyte Ds1307r                                         ' send address
   I2crbyte bcd_sec , Ack
   I2crbyte bcd_min , Ack                                   ' MINUTES
   I2crbyte bcd_hour , Ack                                  ' Hours
   I2crbyte Weekday , Ack                                   ' Day of Week
   I2crbyte bcd_day , Ack                                   ' Day of Month
   I2crbyte bcd_month , Ack                                 ' Month of Year
   I2crbyte bcd_year , Nack                                 ' Year
   I2cstop
   _sec = Makedec(bcd_sec) : _min = Makedec(bcd_min) : _hour = Makedec(bcd_hour)
   _day = Makedec(bcd_day) : _month = Makedec(bcd_month) : _year = Makedec(bcd_year)
   Datum = hex(bcd_day) + "." + hex(bcd_month) + "." + hex(bcd_year)
   Zeit = hex(bcd_hour) + ":" + hex(bcd_min) + ":" + hex(bcd_sec)
End Sub

Sub SetDate()
   bcd_day = Makebcd(_day) : bcd_month = Makebcd(_month) : bcd_year = Makebcd(_year)
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds1307w                                         ' send address
   I2cwbyte 4                                               ' starting address in 1307
   I2cwbyte bcd_day                                         ' Send Data to DAY
   I2cwbyte bcd_month                                       ' MONTH
   I2cwbyte bcd_year                                        ' YEAR
   I2cstop
End Sub

Sub SetTime()
   bcd_sec = Makebcd(_sec) : bcd_min = Makebcd(_min) : bcd_hour = Makebcd(_hour)
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds1307w                                         ' send address
   I2cwbyte 0                                               ' starting address in 1307
   I2cwbyte bcd_sec                                         ' Send Data to SECONDS
   I2cwbyte bcd_min                                         ' MINUTES
   I2cwbyte bcd_hour                                        ' HOURS
   I2cstop
End Sub

Sub Set1307_1sec_tick()
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds1307w                                         ' send address
   I2cwbyte 7                                               ' address in 1307
   I2cwbyte &B11110000                                      ' SQWE = 1 ; 1 sec
   I2cstop
End Sub

MenueEnd: